def remote = [:]
    remote.name = 'ubuntu'
    remote.host = '18.228.218.246'
    remote.allowAnyHosts = true
node{
    checkout([
          $class: 'GitSCM', 
          branches: [[name: "*/master"]], 
          doGenerateSubmoduleConfigurations: false, 
          extensions: [], 
          submoduleCfg: [], 
          userRemoteConfigs: [[
          credentialsId: "git_credentials", 
            url: "https://gitlab.com/dev.raulsouza/sistema-pizzaria.git"
          ]]
        ])
}

pipeline {
    agent {
        node {
            label 'master'
            customWorkspace '/var/lib/jenkins/workspace/sistema-pizzaria-prd'
        }
    }
    tools {
        maven 'MVN'
        jdk 'JDK8'
    }
    stages {
        stage('Checkout') {
            steps {
                checkout scm
                sh 'ls -ltr'
            }
        }
        stage('Build') {
            steps {
                sh 'mvn clean install -f /var/lib/jenkins/workspace/sistema-pizzaria-prd/pom.xml -Dmaven.test.skip.exec'
            }
        }
        stage('Deploy S3') {
            steps {
                withCredentials([[$class: 'AmazonWebServicesCredentialsBinding', accessKeyVariable: 'AWS_ACCESS_KEY_ID', credentialsId: 'JenkinsS3', secretKeyVariable: 'AWS_SECRET_ACCESS_KEY']]) {
                    sh "aws s3 ls"
                    sh "aws s3 cp /var/lib/jenkins/workspace/sistema-pizzaria-prd/target/SistemaPizzariaSouzas-0.0.1.war s3://buckets3pizzaria"
                }
            }
        }    
    }
}
node{
    stage('Deploy servidor') {
        withCredentials([sshUserPrivateKey(credentialsId: 'ubuntu-prd', keyFileVariable: 'identity', passphraseVariable: '', usernameVariable: 'ubuntu')]) {
        remote.user = ubuntu
		remote.identityFile = identity

		sshPut remote: remote, from: '/var/lib/jenkins/workspace/sistema-pizzaria-prd/target/SistemaPizzariaSouzas-0.0.1.war', into: '/home/ubuntu/deployment/'
        sshCommand remote: remote, command: 'sudo cp /home/ubuntu/deployment/SistemaPizzariaSouzas-0.0.1.war /var/lib/tomcat9/webapps/'
        sshCommand remote: remote, command: 'sudo mv /var/lib/tomcat9/webapps/SistemaPizzariaSouzas-0.0.1.war /var/lib/tomcat9/webapps/SistemaPizzariaSouzas.war'
        }        
    }
    stage('Execução') {
        withCredentials([sshUserPrivateKey(credentialsId: 'ubuntu-prd', keyFileVariable: 'identity', passphraseVariable: '', usernameVariable: 'ubuntu')]) {
        remote.user = ubuntu
		remote.identityFile = identity

        sshCommand remote: remote, command: 'sudo service tomcat9 restart'
        }
    }
}
